# PNAS submission portal does not allow uploading .zip files. For this reason, 
# we have changed the format of the Supplementary Data 7.
# In order for this script to run, you need to 
# - delete “.txt” extensions from all the Supplementary Data 7 files
# - create folder “Dataset” with subfolders “data”, “out”, and “trna_ligase”
# - move the .py files into “trna_ligase” folder
# - move the .csv file into “data” folder
# – move the .json and .sh files into the “Dataset” folder 
# - and then run the .sh script by using MacOS terminal.
# - we apologies for any inconvenience with using this script. 
# - Please feel free to contact us at serguey.v.melnikov@gmail.com with any inquiries regarding this script and the data.

#    This scripts collects sequences for aminoacyl-tRNA synthetases with editing domains for species that are listed in 
#    /data/Reduced_table_of_prokaryotes_with_known_genomes.csv file. To use this script for other applications, 
#    please alter the .csv file to select desired organisms and change query.json file 
#    to select desired proteins which sequences you want to retreive. 
#    To run this script, please intal a precompiled version of clustal omega on your computer (we use mac), rename the file to "clustalo", copy it to /usr/bin/local 
#    directory and use command "chmod -R 777 /usr/bin/local/clustalo" to allow local use of clustal omega on your computer. 

#    To run the script, type sh read_me.sh in the terminal

export PYTHONPATH=$PYTHONPATH:.

python trna_ligase/trna_ligase.py \
	data/Reduced_table_of_prokaryotes_with_known_genomes.csv \
	out/ \
	query.json
