
import re
import pandas as pd

### inputs
aa = 'PheRS'
positions = 'VIAT1979,NQ1983,H1994,LI2144'.split(',')
###

fasta_file = '%s_clustalo.fasta' %(aa)
# csv_file = '%s_reduced.csv' %(aa)
csv_file = '%s.csv' %(aa)

fasta_output = '%s_mutants.fasta' %(aa)
csv_output = '%s_new.csv' %(aa)

csv_data = pd.read_csv(csv_file)
csv_data = csv_data.set_index('Entry')
p_dict = {}
poi = {}
for p in positions:
    tmp = re.split(r'([A-Z]+)([0-9]+)', p)
    poi[int(tmp[2])] = tmp[1]

##
def FASTA(filename):
    sequences = {}
    with open('%s' % (filename), mode='r') as infile:
        for line in infile:
            if line.startswith('>'):
                name = line[1:].rstrip('\n')
                name = re.sub('(^\w*) .*', '\\1', name)
                sequences[name] = ''
            else:
                sequences[name] += line.rstrip('\n')
    return (sequences)


sequences = FASTA(fasta_file)
sequences2 = {}
for k, v in sequences.items():
    sequences2[k] = {p: v[p-1] for p in poi.keys()}

##
new_csv = []
for p_name, p_val in sequences2.items():
    new_line = {'Entry': p_name}
    new_line.update(p_val)
    is_mutant = False
    n_mutations = 0
    for p, v in poi.items():
        if new_line[p] not in v:
            is_mutant = True
            n_mutations += 1
    new_line['mutation_status'] = 'mutated' if is_mutant else 'non-mutated'
    new_line['Total number of mutations'] = n_mutations
    new_csv.append(new_line)

new_df = pd.DataFrame(new_csv)
new_df = new_df.set_index('Entry')

# csv_data.join(new_df, on='Entry')
csv_data = csv_data.join(new_df)
csv_data.to_csv(csv_output)
